"""
Module for checking artefact metadata against compliance standards.

This module provides the `CheckArtefactMetadata` class, which is used to
validate the metadata of artefacts to ensure they meet required compliance
standards.

Classes:
    CheckArtefactMetadata: A class that performs validation on artefact
        metadata.
"""

from ska_cicd_artefact_validations.core.artefact import Artefact
from ska_cicd_artefact_validations.core.check import Check
from ska_cicd_artefact_validations.core.logging import logging
from ska_cicd_artefact_validations.core.message_generator import MessageType


class CheckArtefactMetadata(Check):
    """
    A class that performs validation on artefact metadata.

    This class checks the metadata of artefacts to ensure they contain all
    required fields. If any fields are missing, it logs errors and provides
    mitigation strategies.

    Attributes:
        required_fields: A list of metadata fields required for compliance.
        feature_toggle: The feature toggle associated with this check.
        missing_fields: A list of fields missing from the artefact's metadata.
    """

    required_fields = [
        "CI_COMMIT_AUTHOR",
        "CI_COMMIT_REF_NAME",
        "CI_COMMIT_REF_SLUG",
        "CI_COMMIT_SHA",
        "CI_COMMIT_SHORT_SHA",
        "CI_COMMIT_TIMESTAMP",
        "CI_JOB_ID",
        "CI_JOB_URL",
        "CI_PIPELINE_ID",
        "CI_PIPELINE_IID",
        "CI_PIPELINE_URL",
        "CI_PROJECT_ID",
        "CI_PROJECT_PATH_SLUG",
        "CI_PROJECT_URL",
        "CI_RUNNER_ID",
        "CI_RUNNER_REVISION",
        "CI_RUNNER_TAGS",
        "GITLAB_USER_NAME",
        "GITLAB_USER_EMAIL",
        "GITLAB_USER_LOGIN",
        "GITLAB_USER_ID",
    ]
    feature_toggle = "check-component-manifest"

    def __init__(self):
        self.missing_fields = []

    async def check(self, artefact: Artefact) -> bool:
        """
        Checks if the artefact metadata contains all required fields.

        This method validates the artefact's metadata by comparing it against
        the list of required fields.

        :param artefact: The artefact whose metadata is to be validated.
        :return: True if the artefact metadata is compliant, otherwise False.
        """

        self.missing_fields = [
            field
            for field in self.required_fields
            if field not in list(artefact.metadata.keys())
        ]

        if self.missing_fields:
            logging.error("Missing metadata fields: %s", self.missing_fields)
            return False

        return True

    async def type(self) -> MessageType:
        """
        Returns the type of message generated by this check.

        :return: MessageType.FAILURE indicating a failed compliance check.
        """
        return MessageType.FAILURE

    async def description(self) -> str:
        """
        Provides a description of the artefact metadata compliance check.

        :return: A string describing the nature of the check failure.
        """
        return "Non-Compliant/Missing Metadata"

    async def mitigation_strategy(self) -> str:
        """
        Provides a mitigation strategy if the artefact metadata is
        non-compliant.

        This method guides the user on how to correct the artefact
        metadata by listing missing fields and providing a link to
        the relevant guidelines.

        :return: A string with the mitigation strategy and details of missing
            fields.
        """
        missing_fields = "-".join(
            f" {field}\n" for field in self.missing_fields
        )
        return (
            "Artefact metadata is invalid! Please refer to "
            "[the developer portal](https://developer.skatelescope.org/en/latest/tools/software-package-release-procedure.html#metadata) "  # pylint: disable=line-too-long # noqa: E501
            "to correct this issue.\n"
            "Missing fields:\n"
            f"-{missing_fields}"
        )
